#!/usr/bin/python2.4
# ~*~ coding: utf-8
"""
 * statistika mitu asja üks reegel leidis.
 * kookida korpusest välja need laused mis on märgendatud kui sõnajärje viga
 * märgendatud lausetest moodustada reeglid..
"""
import sys
import subprocess
import re
from twisted.enterprise import adbapi
from twisted.internet import reactor

import objects
import rules

dbpool = adbapi.ConnectionPool('psycopg2', user='evkk', database='evkktest')

def getSentences(txn):
    #txn.execute("select documentid, sentences.id, sentence, analysis from sentences left join tagged using (documentid) left join tags on (tags.id=tagged.tag) where label='analüüsida' and not deleted and sentences.id=78145 order by sentences.id")
    txn.execute("select documentid, sentences.id, sentence, analysis from sentences left join tagged using (documentid) left join tags on (tags.id=tagged.tag) where label='analüüsida' and not deleted order by sentences.id")
    res = txn.fetchall()
    return res

def _parse_analysis(txt):
    lines = txt.split('\n')
    words = objects.Pipe()
    for l in lines:
        if not l:
            mi = None
            continue
        if l == '"<s>"' or l == '"</s>"':
            mi = None
            continue
        if l.startswith('"'):
            mi = objects.Word(l[2:-2])
            #mi = {'word': l[2:-2], 'inf': [], 'ignore': False}
            words.append(mi)
        if l.startswith('\t'):
            #mi['inf'].append(l.replace('"'+mi['word']+'"', '').strip())
            mi.addInfo(l.strip())
    return words

def processSentences(res):
    all = []
    for r in res:
        a = r[3]
        #print r[2]
        secount = a.count('<s>')
        if a.count('<s>') != 1: 
            #raise Exception('oioi', str(secount))
            continue
        words = _parse_analysis(a)
        words.documentid = r[0]
        for w in words:
            if w.getWord() in rules.allowed_ignores_words:
                w.setIgnored(True)
        for w in words:
            if w.isIgnored(): continue
            for ir in rules.allowed_ignores_marks:
                for infos in w.getInfo():
                    if ir in infos:
                        #print ir, "ign!"
                        w.setIgnored(True)
        for w in words:
            if w.isIgnored(): continue
            for k, ignv in rules.conditional_ignore.items():
                for infos in w.getInfo():
                    if k in infos:
                        for v in ignv:
                            if v == w.getWord():
                                w.setIgnored(True)
                                #print "ignooring:", k, w.getWord()
        #for w in words:
        #    print w
        for rid, rule in rules.rules:
            #print rule
            match = words.match(rule)
            if match:
                words.addRuleMatch(rid)
                rules.rules.addStat(rid)
        all.append(words)

    print "Sentences:", len(all)
    for a in all:
        print 
        print a
        for rm in a._rulematches:
            print " * "+str(rules.rules.get(rm))
        print " did:"+a.documentid
    rules.rules.printStats()

    reactor.callLater(1, reactor.stop)

def start():
    x = dbpool.runInteraction(getSentences)
    x.addCallback(processSentences)

start()
reactor.run()
