# ~*~ coding: utf-8
import objects

# täiendid. lubatud ignoreerimiseks.
allowed_ignores_marks = ['@AN>', '@<AN', '@DN>', '@<DN', '@KN>', '@<KN', '@NN>', '@<NN', '@VN>', '@INFN>', '@<INFN', '@J', '@Q >', '@<Q', '@P>']

# sõnad lubatud.
allowed_ignores_words = ['ainult', 'arvatavasti', 'eks', 'ent', 'hoopis', 'jah', 'ju', 'juba', 'just', 'ka', 'kas', 'küll', 'küllap', 'las', 'loomulikult', 'minu meelest', 'muidugi', 'no', 'ometi', 'pealegi', 'siis', 'siiski', 'tõenäoliselt', 'vaat', 'veel', 'võib-olla', 'kuigi', 'arvates', 'eelkõige', 'igatahes', 'ilmselt', 'ilmtingimata', 'kahjuks', 'kasvõi', 'kindlasti', 'niisiis', 'samuti', 'seega', 'tõepoolest', 'vist']


# sõnad ignoreerida, kui esineb ADVL märgend?
conditional_ignore = {'ADVL': ['päris', 'üsna', 'väga', 'hästi', 'täielikult', 'mõneti', 'kõige', 'igati', 'nii', 'peamiselt', 'enam', 'liiga', 'tõsiselt']}


#vajalikud.
needed = ['@OBJ',
'@SUBJ',
'@PRD',
'@FMV',
'@FCV',
'@IMV',
'@ADVL',
'_S_',
'_K_',
'_P_',
'@NEG',
'impf ps3 sg',
'_Z_ Fst',
'_Z_ com',
'indic pres',
'indic impf',
'imper',
'neg',
'ad',
'pres ps1',
'pres ps3 sg',
'impf ps1',
'impf ps3 sg',
'//_D_ //  @ADVL ']


# -- lõpp
# imps
# CLB 
# _Z_ Int 
# 
#  ei tohi olla see.
# sellised _S_ ei sobi. otsida midagi muud.
# -- _S_
# _S_ com sg nom
# _S_ com sg gen
# _S_ com sg part
# _S_ com pl nom
# _S_ com pl gen
# _S_ com pl part
# _S_ prop sg nom
# _S_ prop sg gen
# _S_ prop sg part
# _S_ prop pl nom
# _S_ prop pl gen
# _S_ prop pl part


#-- reeglid
rules = objects.RulesList([
    {64: ['@ADVL', '@FMV', '@SUBJ', '@ADVL', '@PRD']},
    {65: ['ad', '@FCV', '@IMV', '_S_', '@SUBJ', '//_D_ //  @ADVL']},
    {66: ['ad', '@FCV', '@IMV', '_K_', '@SUBJ', '//_D_ //  @ADVL']},
    {67: ['ad', '@FCV', '@IMV', '_P_', '@SUBJ', '//_D_ //  @ADVL']},
    {68: ['@SUBJ', '@FCV', '@IMV', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {69: ['@SUBJ', '@FCV', '@IMV', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {70: ['@SUBJ', '@FCV', '@IMV', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {71: ['@SUBJ', '@FCV', '@IMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {72: ['@ADVL', '@OBJ', '@FCV', '//_D_ //  @ADVL', '@IMV']},
    {73: ['@ADVL', '@FMV', '@SUBJ', '@ADVL', '@PRD']},
    {74: ['@SUBJ', '@FCV', '@OBJ', '@IMV', '@IMV']},
    {75: ['@PRD', 'CLB', '@SUBJ', '@FMV', '@ADVL']},
    {76: ['@J', '@ADVL', '@FMV', '@OBJ', '//_D_ //  @ADVL']},
    {77: ['@ADVL', '@FCV', '@ADVL', '@IMV', '@SUBJ']},
    {78: ['@SUBJ', '@FCV', '_S_', '@OBJ', '@IMV']},
    {79: ['@SUBJ', '@FCV', '_K_', '@OBJ', '@IMV']},
    {80: ['@SUBJ', '@FCV', '_P_', '@OBJ', '@IMV']},
    {81: ['@ADVL', '_Z_ com', '@SUBJ', '@FMV', '@ADVL']},
    {82: ['@SUBJ', '@NEG', '@FMV', '_S_', '@OBJ']},
    {83: ['@SUBJ', '@NEG', '@FMV', '_K_', '@OBJ']},
    {84: ['@SUBJ', '@NEG', '@FMV', '_P_', '@OBJ']},
    {85: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@OBJ']},
    {86: ['@ADVL', '@NEG', '@FMV', '_S_', '_X_']},
    {87: ['@SUBJ', '@FMV', '_S_', '@OBJ', '@IMV']},
    {88: ['@SUBJ', '@FMV', '_P_', '@OBJ', '@IMV']},
    {89: ['@SUBJ', '@FMV', '_K_', '@OBJ', '@IMV']},
    {90: ['@SUBJ', '@FCV', '@IMV', '_S_', '@IMV']},
    {91: ['@SUBJ', '@FCV', '@IMV', '_K_', '@IMV']},
    {92: ['@SUBJ', '@FCV', '@IMV', '_P_', '@IMV']},
    {93: ['@FCV', '@IMV', '_S_', '@OBJ', '@IMV']},
    {94: ['@FCV', '@IMV', '_K_', '@OBJ', '@IMV']},
    {95: ['@FCV', '@IMV', '_P_', '@OBJ', '@IMV']},
    {96: ['ad', '@FMV', '_S_', '@SUBJ', '//_D_ //  @ADVL']},
    {97: ['ad', '@FMV', '_K_', '@SUBJ', '//_D_ //  @ADVL']},
    {98: ['ad', '@FMV', '_P_', '@SUBJ', '//_D_ //  @ADVL']},
    {99: ['ad', '@FCV', '_S_', '@SUBJ', '//_D_ //  @ADVL']},
    {100: ['ad', '@FCV', '_K_', '@SUBJ', '//_D_ //  @ADVL']},
    {101: ['ad', '@FCV', '_P_', '@SUBJ', '//_D_ //  @ADVL']},
    {102: ['ad', 'indic pres', '_S_', '@SUBJ', '//_D_ //  @ADVL']},
    {103: ['ad', 'indic pres', '_K_', '@SUBJ', '//_D_ //  @ADVL']},
    {104: ['ad', 'indic pres', '_P_', '@SUBJ', '//_D_ //  @ADVL']},
    {105: ['ad', 'indic impf', '_S_', '@SUBJ', '//_D_ //  @ADVL']},
    {106: ['ad', 'indic impf', '_K_', '@SUBJ', '//_D_ //  @ADVL']},
    {107: ['ad', 'indic impf', '_P_', '@SUBJ', '//_D_ //  @ADVL']},
    {108: ['@SUBJ', '@FCV', '_S_', '//_D_ //  @ADVL', '@IMV']},
    {109: ['@SUBJ', '@FCV', '_K_', '//_D_ //  @ADVL', '@IMV']},
    {110: ['@SUBJ', '@FCV', '_P_', '//_D_ //  @ADVL', '@IMV']},
    {111: ['@SUBJ', '@FCV', '@OBJ', '//_D_ //  @ADVL', '@IMV']},
    {112: ['@SUBJ', '@FMV', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {113: ['@SUBJ', '@FMV', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {114: ['@SUBJ', '@FMV', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {115: ['@SUBJ', '@FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {116: ['ps1', '@IMV', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {117: ['ps1', '@IMV', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {118: ['ps1', '@IMV', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {119: ['ps1', '@IMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {120: ['ps3 sg', '@IMV', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {121: ['ps3 sg', '@IMV', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {122: ['ps3 sg', '@IMV', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {123: ['ps3 sg', '@IMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {124: ['@SUBJ', '@FCV', '@IMV', '_X_', '@OBJ']},
    {125: ['@ADVL', '@FCV', '@SUBJ', '@OBJ', '@IMV']},
    {126: ['_S_', '@FMV', '@SUBJ', '@IMV', '@OBJ']},
    {127: ['_K_', '@FMV', '@SUBJ', '@IMV', '@OBJ']},
    {128: ['_P_', '@FMV', '@SUBJ', '@IMV', '@OBJ']},
    {129: ['@ADVL', '@FMV', '@SUBJ', '@OBJ', '@IMV']},
    {130: ['@ADVL', '@FMV', '_S_', '@OBJ']},
    {131: ['@ADVL', '@FMV', '_K_', '@OBJ']},
    {132: ['@ADVL', '@FMV', '_P_', '@OBJ']},
    {133: ['@SUBJ', '@FCV', '_S_', '@IMV']},
    {134: ['@SUBJ', '@FCV', '_K_', '@IMV']},
    {135: ['@SUBJ', '@FCV', '_P_', '@IMV']},
    {136: ['@SUBJ', '@FCV', '@OBJ', '@IMV']},
    {137: ['@ADVL', '@FCV', '@SUBJ', '@ADVL']},
    {138: ['@PRD', '@FMV', '@ADVL', '@SUBJ']},
    {139: ['@SUBJ', '@FMV', '@OBJ', '_S_']},
    {140: ['@SUBJ', '@FMV', '@OBJ', '_K_']},
    {141: ['@SUBJ', '@FMV', '@OBJ', '_P_']},
    {142: ['@ADVL', '@FCV', '@SUBJ', '@OBJ']},
    {143: ['@ADVL', '@SUBJ', '@FMV', '@ADVL']},
    {144: ['@FCV', '_S_', '//_D_ //  @ADVL', '@IMV']},
    {145: ['@FCV', '_K_', '//_D_ //  @ADVL', '@IMV']},
    {146: ['@FCV', '_P_', '//_D_ //  @ADVL', '@IMV']},
    {147: ['@ADVL', '@FMV', '@SUBJ', '@ADVL']},
    {148: ['CLB', '@FMV', '@ADVL', '@SUBJ']},
    {149: ['@ADVL', '@FMV', '//_D_ //  @ADVL', '@SUBJ']},
    {150: ['@SUBJ', '@FMV', '_K_', '@OBJ']},
    {151: ['@J', '@FMV', '@SUBJ', '@PRD']},
    {152: ['@SUBJ', '@FMV', '_K_', '_S_']},
    {153: ['@SUBJ', '@FMV', '_K_', '_K_']},
    {154: ['@SUBJ', '@FMV', '_K_', '_P_']},
    {155: ['@SUBJ', '@ADVL', '@FMV', '@OBJ']},
    {156: ['@SUBJ', '@OBJ', '@NEG', '@FMV']},
    {157: ['@J', '@SUBJ', '@NEG', '@FMV']},
    {158: ['@SUBJ', '@NEG', '@FMV', '_S_']},
    {159: ['@SUBJ', '@NEG', '@FMV', '_K_']},
    {160: ['@SUBJ', '@NEG', '@FMV', '_P_']},
    {161: ['@ADVL', '@NEG', '@FMV', '_K_']},
    {162: ['@ADVL', '@NEG', '@FMV', '_P_']},
    {163: ['@SUBJ', '@FCV', '@ADVL', '@IMV']},
    {164: ['@SUBJ', '@FCV', '@IMV', '@ADVL']},
    {165: ['@SUBJ', '@NEG', '@FMV', '@OBJ']},
    {166: ['@SUBJ', '@FCV', '@IMV', '_S_']},
    {167: ['@SUBJ', '@FCV', '@IMV', '_K_']},
    {168: ['@SUBJ', '@FCV', '@IMV', '_P_']},
    {169: ['@SUBJ', '@NEG', '@FCV', '@IMV']},
    {170: ['@SUBJ', '@NEG', '@FCV', '@OBJ']},
    {171: ['@ADVL', '@FMV', '@SUBJ', '@PRD']},
    {172: ['@ADVL', '@FMV', '@ADVL', '@SUBJ']},
    {173: ['@SUBJ', 'indic pres', '_S_', '@OBJ']},
    {174: ['@SUBJ', 'indic pres', '_K_', '@OBJ']},
    {175: ['@SUBJ', 'indic pres', '_P_', '@OBJ']},
    {176: ['@SUBJ', 'indic impf', '_S_', '@OBJ']},
    {177: ['@SUBJ', 'indic impf', '_K_', '@OBJ']},
    {178: ['@SUBJ', 'indic impf', '_P_', '@OBJ']},
    {179: ['@SUBJ', '@FMV', '_P_', '@OBJ']},
    {180: ['@FCV', '_S_', '@OBJ', '@IMV']},
    {181: ['@FCV', '_K_', '@OBJ', '@IMV']},
    {182: ['@FCV', '_P_', '@OBJ', '@IMV']},
    {183: ['ps1', '_K_', '@OBJ', '@IMV']},
    {184: ['ps1', '_P_', '@OBJ', '@IMV']},
    {185: ['ps3 sg', '_K_', '@OBJ', '@IMV']},
    {186: ['ps3 sg', '_P_', '@OBJ', '@IMV']},
    {187: ['imper', '_S_', '@OBJ', '@IMV']},
    {188: ['imper', '_P_', '@OBJ', '@IMV']},
    {189: ['@SUBJ', '@FCV', '@OBJ', '@IMV']},
    {190: ['neg', '@FMV', '_S_', '//_D_ //  @ADVL']},
    {191: ['neg', '@FMV', '_K_', '//_D_ //  @ADVL']},
    {192: ['neg', '@FMV', '_P_', '//_D_ //  @ADVL']},
    {193: ['@SUBJ', '@FMV', '_S_', '//_D_ //  @ADVL']},
    {194: ['@SUBJ', '@FMV', '_K_', '//_D_ //  @ADVL']},
    {195: ['@SUBJ', '@FMV', '_P_', '//_D_ //  @ADVL']},
    {196: ['@SUBJ', '@FMV', '@OBJ', '//_D_ //  @ADVL']},
    {197: ['@SUBJ', '@FCV', '_S_', '//_D_ //  @ADVL']},
    {198: ['@SUBJ', '@FCV', '_K_', '//_D_ //  @ADVL']},
    {199: ['@SUBJ', '@FCV', '_P_', '//_D_ //  @ADVL']},
    {200: ['@SUBJ', '@FCV', '@OBJ', '//_D_ //  @ADVL']},
    {201: ['imper', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {202: ['imper', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {203: ['imper', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {204: ['imper', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {205: ['@FCV', '@OBJ', '//_D_ //  @ADVL', '@IMV']},
    {206: ['pres ps1', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {207: ['pres ps1', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {208: ['pres ps1', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {209: ['pres ps1', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {210: ['pres ps3 sg', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {211: ['pres ps3 sg', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {212: ['pres ps3 sg', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {213: ['pres ps3 sg', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {214: ['impf ps1', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {215: ['impf ps1', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {216: ['impf ps1', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {217: ['impf ps1', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {218: ['impf ps3 sg', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {219: ['impf ps3 sg', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {220: ['impf ps3 sg', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {221: ['impf ps3 sg', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {222: ['@FMV', '_S_', '//_D_ //  @ADVL', '@OBJ']},
    {223: ['@FMV', '_K_', '//_D_ //  @ADVL', '@OBJ']},
    {224: ['@FMV', '_P_', '//_D_ //  @ADVL', '@OBJ']},
    {225: ['@FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ']},
    {226: ['@SUBJ', '@FCV', '_X_', '@IMV']},
    {227: ['@SUBJ', '@FMV', '_X_', '@OBJ']},
    {228: ['@ADVL', '@FCV', '@SUBJ', '@IMV']},
    {229: ['@SUBJ', '@FMV', '@OBJ', '@ADVL']},
    {230: ['@ADVL', '@FMV', '@SUBJ', '@IMV']},
    {231: ['@SUBJ', '@NEG', '@FMV', '@IMV']},
    {232: ['@ADVL', '@FMV', '@SUBJ', '@OBJ']},
    {233: ['@SUBJ', '@FMV', '@PRD']},
    {234: ['@SUBJ', '@FMV', '_S_']},
    {235: ['@SUBJ', '@FMV', '_K_']},
    {236: ['@SUBJ', '@FMV', '_P_']},
    {237: ['@ADVL', '@FMV', '@SUBJ']},
    {238: ['@ADVL', '@FMV', '@OBJ']},
    {239: ['@SUBJ', '@FCV', '@PRD']},
    {240: ['@SUBJ', '@FMV', '@ADVL']},
    {241: ['@SUBJ', '@FMV', '_Z_ Fst']},
    {242: ['@SUBJ', '@FCV', '@IMV']},
    {243: ['@OBJ', '@FMV', '@ADVL']},
    {244: ['@FMV', '@PRD', '_Z_ Fst']},
    {245: ['@ADVL', '@FCV', '@SUBJ']},
    {246: ['@SUBJ', '@FMV', '@IMV']},
    {247: ['@FMV', '@ADVL', '@PRD']},
    {248: ['@SUBJ', '@FMV', '@OBJ']},
    {249: ['@SUBJ', '@FMV', '@IMV']},
    {250: ['@FCV', '@OBJ', '@IMV']},
    {251: ['@FMV', '@ADVL', '_Z_ Fst']},
    {252: ['@SUBJ', '@NEG', '@FMV']},
    {253: ['@FMV', '@OBJ', '_Z_ Fst']},
    {254: ['ps3 sg', '//_D_ //  @ADVL', '_Z_ Fst']},
    {255: ['ps1', '@OBJ', '_Z_ Fst']},
    {256: ['ps3 sg', '@ADVL', '_Z_ Fst']},
    {257: ['ps3 sg', '@IMV', '_Z_ Fst']},
    {258: ['ps3 sg', '@PRD', '_Z_ Fst']},
    {259: ['@SUBJ', '@FMV', '@IMV']},
    {260: ['@FMV', '@SUBJ', '_Z_ Fst']},
    {261: ['@ADVL', '@FMV', '@ADVL']},
    {262: ['imper', '_S_', '@OBJ']},
    {263: ['imper', '_K_', '@OBJ']},
    {264: ['imper', '_P_', '@OBJ']},
    {265: ['ps1', '_S_', '@OBJ']},
    {266: ['ps1', '_K_', '@OBJ']},
    {267: ['ps1', '_P_', '@OBJ']},
    {268: ['ps3 sg', '_S_', '@OBJ']},
    {269: ['ps3 sg', '_K_', '@OBJ']},
    {270: ['ps3 sg', '_P_', '@OBJ']},
    {271: ['@FMV', '_S_', '@OBJ']},
    {272: ['@FMV', '_K_', '@OBJ']},
    {273: ['@FMV', '_P_', '@OBJ']},
    {274: ['imper', '@OBJ', '_Z_ Fst']},
    {275: ['@SUBJ', '@FCV', '_S_']},
    {276: ['@SUBJ', '@FCV', '_K_']},
    {277: ['imper', '_S_', '_Z_ Fst']},
    {278: ['imper', '_K_', '_Z_ Fst']},
    {279: ['imper', '_P_', '_Z_ Fst']},
    {280: ['imper', '_S_', '//_D_ //  @ADVL']},
    {281: ['imper', '_K_', '//_D_ //  @ADVL']},
    {282: ['imper', '_P_', '//_D_ //  @ADVL']},
    {283: ['imper', '@OBJ', '//_D_ //  @ADVL']},
    {284: ['pres ps1', '_S_', '//_D_ //  @ADVL']},
    {285: ['pres ps1', '_K_', '//_D_ //  @ADVL']},
    {286: ['pres ps1', '_P_', '//_D_ //  @ADVL']},
    {287: ['pres ps1', '@OBJ', '//_D_ //  @ADVL']},
    {288: ['pres ps3 sg', '_S_', '//_D_ //  @ADVL']},
    {289: ['pres ps3 sg', '_K_', '//_D_ //  @ADVL']},
    {290: ['pres ps3 sg', '_P_', '//_D_ //  @ADVL']},
    {291: ['pres ps3 sg', '@OBJ', '//_D_ //  @ADVL']},
    {292: ['impf ps1', '_S_', '//_D_ //  @ADVL']},
    {293: ['impf ps1', '_K_', '//_D_ //  @ADVL']},
    {294: ['impf ps1', '_P_', '//_D_ //  @ADVL']},
    {295: ['impf ps1', '@OBJ', '//_D_ //  @ADVL']},
    {296: ['impf ps3 sg', '_S_', '//_D_ //  @ADVL']},
    {297: ['impf ps3 sg', '_K_', '//_D_ //  @ADVL']},
    {298: ['impf ps3 sg', '_P_', '//_D_ //  @ADVL']},
    {299: ['impf ps3 sg', '@OBJ', '//_D_ //  @ADVL']},
    {300: ['@SUBJ', '@FMV', '_X_']},
    {301: ['@SUBJ', '@FCV', '_X_']},
    {302: ['@FCV', '_X_', '@IMV']},
    {303: ['@FMV', '_X_', '@OBJ']},
    {304: ['//_D_ //  @ADVL', '@FMV', '@SUBJ']},
    {305: ['impf ps3 sg', '_P_', '//_D_ //  @ADVL']},
    {306: ['@FMV', '_Z_ Fst']},
    {307: ['imper', '_X_']}
])

