#!/usr/bin/python2.4
# ~*~ coding: utf-8
"""
 * statistika mitu asja üks reegel leidis.
 * kookida korpusest välja need laused mis on märgendatud kui sõnajärje viga
 * märgendatud lausetest moodustada reeglid..
"""
import sys
import subprocess
import re
from twisted.enterprise import adbapi
from twisted.internet import reactor

import objects
import rules

dbpool = adbapi.ConnectionPool('psycopg2', user='evkk', database='evkktest')

def getSentences():
    res = []
    f = open('input.txt', 'rb')
    contents = f.read()
    f.close()
    k = re.findall('("<s>.*?<\/s>")', contents, re.S)
    # documentid, sentences.id, sentence, analysis
    for l in k:
        tmp = []
        tmp.append('-')
        tmp.append('-')
        tmp.append('-')
        tmp.append(l)
        res.append(tmp)
    return res

def _parse_analysis(txt):
    lines = txt.split('\n')
    words = objects.Pipe()
    for l in lines:
        if not l:
            mi = None
            continue
        if l == '"<s>"' or l == '"</s>"':
            mi = None
            continue
        if l.startswith('"'):
            mi = objects.Word(l[2:-2])
            #mi = {'word': l[2:-2], 'inf': [], 'ignore': False}
            words.append(mi)
        if l.startswith('\t'):
            #mi['inf'].append(l.replace('"'+mi['word']+'"', '').strip())
            mi.addInfo(l.strip())
    return words

def processSentences(res):
    all = []
    for r in res:
        a = r[3]
        #print r[2]
        secount = a.count('<s>')
        if a.count('<s>') != 1: 
            #raise Exception('oioi', str(secount))
            continue
        words = _parse_analysis(a)
        words.documentid = r[0]
        for w in words:
            if w.getWord() in rules.allowed_ignores_words:
                w.setIgnored(True)
        for w in words:
            if w.isIgnored(): continue
            for ir in rules.allowed_ignores_marks:
                for infos in w.getInfo():
                    if ir in infos:
                        #print ir, "ign!"
                        w.setIgnored(True)
        for w in words:
            if w.isIgnored(): continue
            for k, ignv in rules.conditional_ignore.items():
                for infos in w.getInfo():
                    if k in infos:
                        for v in ignv:
                            if v == w.getWord():
                                w.setIgnored(True)
                                #print "ignooring:", k, w.getWord()
        #for w in words:
        #    print w
        for rid, rule in rules.rules:
            #print rule
            match = words.match(rule)
            if match:
                words.addRuleMatch(rid)
                rules.rules.addStat(rid)
        all.append(words)

    print "Sentences:", len(all)
    for a in all:
        print 
        print a
        if len(a._rulematches) > 0:
            for rm in a._rulematches:
                print " * "+str(rules.rules.get(rm))
        else:
            print "No rules matching"
            try:
                print a.getPossibleRule(rules.needed, debug=1)
            except Exception, e:
                print "ERROR:", str(e)
        print " did:"+a.documentid
    rules.rules.printStats()

    print "\n"
    print "Possible rules"
    print
    new_count = {}
    pose_map = {}
    new_f = open('possible.txt', 'w')
    for a in all:
        if len(a._rulematches) == 0:
            try:
                pose = a.getPossibleRule(rules.needed)
                posekey = '\t'.join(pose)
                pose_map[posekey] = pose
                if new_count.has_key(posekey):
                    new_count[posekey] = new_count[posekey] + 1
                else:
                    new_count[posekey] = 1
            except Exception, e:
                print "ERROR:", str(e)
    news = new_count.items()
    news.sort(key=lambda x: x[1], reverse=True)
    total = 0
    print >> new_f, """import objects
dyn_rules = objects.RulesList(["""
    for i, n in enumerate(news):
        print n[1], n[0]
        total += n[1]
        print >> new_f, "\t{"+str(i)+": "+str(pose_map[n[0]])+"}",
        if len(news) - 1 != i:
            print >> new_f, ","
        else:
            print >> new_f
    print >> new_f, "])"
    print "Total possible new:", total
    new_f.close()
    reactor.callLater(1, reactor.stop)

def start():
    sentences = getSentences()
    #for s in sentences:
    processSentences(sentences[:])

start()
reactor.run()
