# ~*~ coding: utf-8
import objects

# täiendid. lubatud ignoreerimiseks.
allowed_ignores_marks = [
    '@AN>', '@<AN', '@DN>', '@<DN', '@KN>', '@<KN', '@NN>',
    '@<NN', '@VN>', '@INFN>', '@<INFN', '@J', '@Q >', '@<Q', '@P>'
]

# sõnad lubatud.
allowed_ignores_words = [
    'ainult', 'arvatavasti', 'eks', 'ent', 'hoopis', 'jah', 'ju', 'juba', 'just',
    'ka', 'kas', 'küll', 'küllap', 'las', 'loomulikult', 'minu meelest', 'muidugi',
    'no', 'ometi', 'pealegi', 'siis', 'siiski', 'tõenäoliselt', 'vaat', 'veel', 'võib-olla',
    'kuigi', 'arvates', 'eelkõige', 'igatahes', 'ilmselt', 'ilmtingimata', 'kahjuks',
    'kasvõi', 'kindlasti', 'niisiis', 'samuti', 'seega', 'tõepoolest', 'vist'
]


# sõnad ignoreerida, kui esineb ADVL märgend?
conditional_ignore = {
    'ADVL': ['päris', 'üsna', 'väga', 'hästi', 'täielikult', 'mõneti', 'kõige',
             'igati', 'nii', 'peamiselt', 'enam', 'liiga', 'tõsiselt']
}


#vajalikud.
needed = [
    '@OBJ', '@SUBJ', '@PRD', '@FMV', '@FCV', '@IMV', '@ADVL', ' S ', ' K ', ' P ', '@NEG',
    'impf ps3 sg', 'Z Fst', 'Z Com', 'indic pres', 'indic impf', 'imper', 'neg', 'ad', 'pres ps1',
    'pres ps3 sg', 'impf ps1', 'impf ps3 sg', 'D cap @ADVL'
]


# -- lõpp
# imps
# CLB 
# Z Int 
# 
#  ei tohi olla see.
# sellised S ei sobi. otsida midagi muud.
# -- S
# S com sg nom
# S com sg gen
# S com sg part
# S com pl nom
# S com pl gen
# S com pl part
# S prop sg nom
# S prop sg gen
# S prop sg part
# S prop pl nom
# S prop pl gen
# S prop pl part


#-- reeglid
rules = objects.RulesList([
    {64: ['@ADVL', '@FMV', '@SUBJ', '@ADVL', '@PRD']},
    {65: ['ad', '@FCV', '@IMV', ' S ', '@SUBJ', 'D cap @ADVL']},
    {66: ['ad', '@FCV', '@IMV', ' K ', '@SUBJ', 'D cap @ADVL']},
    {67: ['ad', '@FCV', '@IMV', ' P ', '@SUBJ', 'D cap @ADVL']},
    {68: ['@SUBJ', '@FCV', '@IMV', ' S ', 'D cap @ADVL', '@OBJ']},
    {69: ['@SUBJ', '@FCV', '@IMV', ' K ', 'D cap @ADVL', '@OBJ']},
    {70: ['@SUBJ', '@FCV', '@IMV', ' P ', 'D cap @ADVL', '@OBJ']},
    {71: ['@SUBJ', '@FCV', '@IMV', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {72: ['@ADVL', '@OBJ', '@FCV', 'D cap @ADVL', '@IMV']},
    {73: ['@ADVL', '@FMV', '@SUBJ', '@ADVL', '@PRD']},
    {74: ['@SUBJ', '@FCV', '@OBJ', '@IMV', '@IMV']},
    {77: ['@ADVL', '@FCV', '@ADVL', '@IMV', '@SUBJ']},
    {78: ['@SUBJ', '@FCV', ' S ', '@OBJ', '@IMV']},
    {79: ['@SUBJ', '@FCV', ' K ', '@OBJ', '@IMV']},
    {80: ['@SUBJ', '@FCV', ' P ', '@OBJ', '@IMV']},
    {81: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', '@ADVL']},
    {82: ['@SUBJ', '@NEG', '@FMV', ' S ', '@OBJ']},
    {83: ['@SUBJ', '@NEG', '@FMV', ' K ', '@OBJ']},
    {84: ['@SUBJ', '@NEG', '@FMV', ' P ', '@OBJ']},
    {85: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@OBJ']},
    {86: ['@ADVL', '@NEG', '@FMV', ' S ', ' X ']},
    {87: ['@SUBJ', '@FMV', ' S ', '@OBJ', '@IMV']},
    {88: ['@SUBJ', '@FMV', ' P ', '@OBJ', '@IMV']},
    {89: ['@SUBJ', '@FMV', ' K ', '@OBJ', '@IMV']},
    {90: ['@SUBJ', '@FCV', '@IMV', ' S ', '@IMV']},
    {91: ['@SUBJ', '@FCV', '@IMV', ' K ', '@IMV']},
    {92: ['@SUBJ', '@FCV', '@IMV', ' P ', '@IMV']},
    {93: ['@FCV', '@IMV', ' S ', '@OBJ', '@IMV']},
    {94: ['@FCV', '@IMV', ' K ', '@OBJ', '@IMV']},
    {95: ['@FCV', '@IMV', ' P ', '@OBJ', '@IMV']},
    {96: ['ad', '@FMV', ' S ', '@SUBJ', 'D cap @ADVL']},
    {97: ['ad', '@FMV', ' K ', '@SUBJ', 'D cap @ADVL']},
    {98: ['ad', '@FMV', ' P ', '@SUBJ', 'D cap @ADVL']},
    {99: ['ad', '@FCV', ' S ', '@SUBJ', 'D cap @ADVL']},
    {100: ['ad', '@FCV', ' K ', '@SUBJ', 'D cap @ADVL']},
    {101: ['ad', '@FCV', ' P ', '@SUBJ', 'D cap @ADVL']},
    {102: ['ad', 'indic pres', ' S ', '@SUBJ', 'D cap @ADVL']},
    {103: ['ad', 'indic pres', ' K ', '@SUBJ', 'D cap @ADVL']},
    {104: ['ad', 'indic pres', ' P ', '@SUBJ', 'D cap @ADVL']},
    {105: ['ad', 'indic impf', ' S ', '@SUBJ', 'D cap @ADVL']},
    {106: ['ad', 'indic impf', ' K ', '@SUBJ', 'D cap @ADVL']},
    {107: ['ad', 'indic impf', ' P ', '@SUBJ', 'D cap @ADVL']},
    {108: ['@SUBJ', '@FCV', ' S ', 'D cap @ADVL', '@IMV']},
    {109: ['@SUBJ', '@FCV', ' K ', 'D cap @ADVL', '@IMV']},
    {110: ['@SUBJ', '@FCV', ' P ', 'D cap @ADVL', '@IMV']},
    {111: ['@SUBJ', '@FCV', '@OBJ', 'D cap @ADVL', '@IMV']},
    {112: ['@SUBJ', '@FMV', ' S ', 'D cap @ADVL', '@OBJ']},
    {113: ['@SUBJ', '@FMV', ' K ', 'D cap @ADVL', '@OBJ']},
    {114: ['@SUBJ', '@FMV', ' P ', 'D cap @ADVL', '@OBJ']},
    {115: ['@SUBJ', '@FMV', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {116: ['ps1', '@IMV', ' S ', 'D cap @ADVL', '@OBJ']},
    {117: ['ps1', '@IMV', ' K ', 'D cap @ADVL', '@OBJ']},
    {118: ['ps1', '@IMV', ' P ', 'D cap @ADVL', '@OBJ']},
    {119: ['ps1', '@IMV', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {120: ['ps3 sg', '@IMV', ' S ', 'D cap @ADVL', '@OBJ']},
    {121: ['ps3 sg', '@IMV', ' K ', 'D cap @ADVL', '@OBJ']},
    {122: ['ps3 sg', '@IMV', ' P ', 'D cap @ADVL', '@OBJ']},
    {123: ['ps3 sg', '@IMV', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {124: ['@SUBJ', '@FCV', '@IMV', ' X ', '@OBJ']},
    {125: ['@ADVL', '@FCV', '@SUBJ', '@OBJ', '@IMV']},
    {126: [' S ', '@FMV', '@SUBJ', '@IMV', '@OBJ']},
    {127: [' K ', '@FMV', '@SUBJ', '@IMV', '@OBJ']},
    {128: [' P ', '@FMV', '@SUBJ', '@IMV', '@OBJ']},
    {129: ['@ADVL', '@FMV', '@SUBJ', '@OBJ', '@IMV']},
    {130: ['@ADVL', '@FMV', ' S ', '@OBJ']},
    {131: ['@ADVL', '@FMV', ' K ', '@OBJ']},
    {132: ['@ADVL', '@FMV', ' P ', '@OBJ']},
    {133: ['@SUBJ', '@FCV', ' S ', '@IMV']},
    {134: ['@SUBJ', '@FCV', ' K ', '@IMV']},
    {135: ['@SUBJ', '@FCV', ' P ', '@IMV']},
    {136: ['@SUBJ', '@FCV', '@OBJ', '@IMV']},
    {137: ['@ADVL', '@FCV', '@SUBJ', '@ADVL']},
    {138: ['@PRD', '@FMV', '@ADVL', '@SUBJ']},
    {139: ['@SUBJ', '@FMV', '@OBJ', ' S ']},
    {140: ['@SUBJ', '@FMV', '@OBJ', ' K ']},
    {141: ['@SUBJ', '@FMV', '@OBJ', ' P ']},
    {142: ['@ADVL', '@FCV', '@SUBJ', '@OBJ']},
    {143: ['@ADVL', '@SUBJ', '@FMV', '@ADVL']},
    {144: ['@FCV', ' S ', 'D cap @ADVL', '@IMV']},
    {145: ['@FCV', ' K ', 'D cap @ADVL', '@IMV']},
    {146: ['@FCV', ' P ', 'D cap @ADVL', '@IMV']},
    {147: ['@ADVL', '@FMV', '@SUBJ', '@ADVL']},
    {148: ['CLB', '@FMV', '@ADVL', '@SUBJ']},
    {149: ['@ADVL', '@FMV', 'D cap @ADVL', '@SUBJ']},
    {150: ['@SUBJ', '@FMV', ' K ', '@OBJ']},
    {151: ['@FMV', '@SUBJ', '@PRD']},
    {152: ['@SUBJ', '@FMV', ' K ', ' S ']},
    {153: ['@SUBJ', '@FMV', ' K ', ' K ']},
    {154: ['@SUBJ', '@FMV', ' K ', ' P ']},
    {155: ['@SUBJ', '@ADVL', '@FMV', '@OBJ']},
    {156: ['@SUBJ', '@OBJ', '@NEG', '@FMV']},
    {157: ['@SUBJ', '@NEG', '@FMV']},
    {158: ['@SUBJ', '@NEG', '@FMV', ' S ']},
    {159: ['@SUBJ', '@NEG', '@FMV', ' K ']},
    {160: ['@SUBJ', '@NEG', '@FMV', ' P ']},
    {161: ['@ADVL', '@NEG', '@FMV', ' K ']},
    {162: ['@ADVL', '@NEG', '@FMV', ' P ']},
    {163: ['@SUBJ', '@FCV', '@ADVL', '@IMV']},
    {164: ['@SUBJ', '@FCV', '@IMV', '@ADVL']},
    {165: ['@SUBJ', '@NEG', '@FMV', '@OBJ']},
    {166: ['@SUBJ', '@FCV', '@IMV', ' S ']},
    {167: ['@SUBJ', '@FCV', '@IMV', ' K ']},
    {168: ['@SUBJ', '@FCV', '@IMV', ' P ']},
    {169: ['@SUBJ', '@NEG', '@FCV', '@IMV']},
    {170: ['@SUBJ', '@NEG', '@FCV', '@OBJ']},
    {171: ['@ADVL', '@FMV', '@SUBJ', '@PRD']},
    {172: ['@ADVL', '@FMV', '@ADVL', '@SUBJ']},
    {173: ['@SUBJ', 'indic pres', ' S ', '@OBJ']},
    {174: ['@SUBJ', 'indic pres', ' K ', '@OBJ']},
    {175: ['@SUBJ', 'indic pres', ' P ', '@OBJ']},
    {176: ['@SUBJ', 'indic impf', ' S ', '@OBJ']},
    {177: ['@SUBJ', 'indic impf', ' K ', '@OBJ']},
    {178: ['@SUBJ', 'indic impf', ' P ', '@OBJ']},
    {179: ['@SUBJ', '@FMV', ' P ', '@OBJ']},
    {180: ['@FCV', ' S ', '@OBJ', '@IMV']},
    {181: ['@FCV', ' K ', '@OBJ', '@IMV']},
    {182: ['@FCV', ' P ', '@OBJ', '@IMV']},
    {183: ['ps1', ' K ', '@OBJ', '@IMV']},
    {184: ['ps1', ' P ', '@OBJ', '@IMV']},
    {185: ['ps3 sg', ' K ', '@OBJ', '@IMV']},
    {186: ['ps3 sg', ' P ', '@OBJ', '@IMV']},
    {187: ['imper', ' S ', '@OBJ', '@IMV']},
    {188: ['imper', ' P ', '@OBJ', '@IMV']},
    {189: ['@SUBJ', '@FCV', '@OBJ', '@IMV']},
    {190: ['neg', '@FMV', ' S ', 'D cap @ADVL']},
    {191: ['neg', '@FMV', ' K ', 'D cap @ADVL']},
    {192: ['neg', '@FMV', ' P ', 'D cap @ADVL']},
    {193: ['@SUBJ', '@FMV', ' S ', 'D cap @ADVL']},
    {194: ['@SUBJ', '@FMV', ' K ', 'D cap @ADVL']},
    {195: ['@SUBJ', '@FMV', ' P ', 'D cap @ADVL']},
    {196: ['@SUBJ', '@FMV', '@OBJ', 'D cap @ADVL']},
    {197: ['@SUBJ', '@FCV', ' S ', 'D cap @ADVL']},
    {198: ['@SUBJ', '@FCV', ' K ', 'D cap @ADVL']},
    {199: ['@SUBJ', '@FCV', ' P ', 'D cap @ADVL']},
    {200: ['@SUBJ', '@FCV', '@OBJ', 'D cap @ADVL']},
    {201: ['imper', ' S ', 'D cap @ADVL', '@OBJ']},
    {202: ['imper', ' K ', 'D cap @ADVL', '@OBJ']},
    {203: ['imper', ' P ', 'D cap @ADVL', '@OBJ']},
    {204: ['imper', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {205: ['@FCV', '@OBJ', 'D cap @ADVL', '@IMV']},
    {206: ['pres ps1', ' S ', 'D cap @ADVL', '@OBJ']},
    {207: ['pres ps1', ' K ', 'D cap @ADVL', '@OBJ']},
    {208: ['pres ps1', ' P ', 'D cap @ADVL', '@OBJ']},
    {209: ['pres ps1', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {210: ['pres ps3 sg', ' S ', 'D cap @ADVL', '@OBJ']},
    {211: ['pres ps3 sg', ' K ', 'D cap @ADVL', '@OBJ']},
    {212: ['pres ps3 sg', ' P ', 'D cap @ADVL', '@OBJ']},
    {213: ['pres ps3 sg', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {214: ['impf ps1', ' S ', 'D cap @ADVL', '@OBJ']},
    {215: ['impf ps1', ' K ', 'D cap @ADVL', '@OBJ']},
    {216: ['impf ps1', ' P ', 'D cap @ADVL', '@OBJ']},
    {217: ['impf ps1', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {218: ['impf ps3 sg', ' S ', 'D cap @ADVL', '@OBJ']},
    {219: ['impf ps3 sg', ' K ', 'D cap @ADVL', '@OBJ']},
    {220: ['impf ps3 sg', ' P ', 'D cap @ADVL', '@OBJ']},
    {221: ['impf ps3 sg', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {222: ['@FMV', ' S ', 'D cap @ADVL', '@OBJ']},
    {223: ['@FMV', ' K ', 'D cap @ADVL', '@OBJ']},
    {224: ['@FMV', ' P ', 'D cap @ADVL', '@OBJ']},
    {225: ['@FMV', '@OBJ', 'D cap @ADVL', '@OBJ']},
    {226: ['@SUBJ', '@FCV', ' X ', '@IMV']},
    {227: ['@SUBJ', '@FMV', ' X ', '@OBJ']},
    {228: ['@ADVL', '@FCV', '@SUBJ', '@IMV']},
    {229: ['@SUBJ', '@FMV', '@OBJ', '@ADVL']},
    {230: ['@ADVL', '@FMV', '@SUBJ', '@IMV']},
    {231: ['@SUBJ', '@NEG', '@FMV', '@IMV']},
    {232: ['@ADVL', '@FMV', '@SUBJ', '@OBJ']},
    {233: ['@SUBJ', '@FMV', '@PRD']},
    {234: ['@SUBJ', '@FMV', ' S ']},
    {235: ['@SUBJ', '@FMV', ' K ']},
    {236: ['@SUBJ', '@FMV', ' P ']},
    {237: ['@ADVL', '@FMV', '@SUBJ']},
    {238: ['@ADVL', '@FMV', '@OBJ']},
    {239: ['@SUBJ', '@FCV', '@PRD']},
    {240: ['@SUBJ', '@FMV', '@ADVL']},
    {241: ['@SUBJ', '@FMV', 'Z Fst']},
    {242: ['@SUBJ', '@FCV', '@IMV']},
    {243: ['@OBJ', '@FMV', '@ADVL']},
    {244: ['@FMV', '@PRD', 'Z Fst']},
    {245: ['@ADVL', '@FCV', '@SUBJ']},
    {246: ['@SUBJ', '@FMV', '@IMV']},
    {247: ['@FMV', '@ADVL', '@PRD']},
    {248: ['@SUBJ', '@FMV', '@OBJ']},
    {249: ['@SUBJ', '@FMV', '@IMV']},
    {250: ['@FCV', '@OBJ', '@IMV']},
    {251: ['@FMV', '@ADVL', 'Z Fst']},
    {252: ['@SUBJ', '@NEG', '@FMV']},
    {253: ['@FMV', '@OBJ', 'Z Fst']},
    {254: ['ps3 sg', 'D cap @ADVL', 'Z Fst']},
    {255: ['ps1', '@OBJ', 'Z Fst']},
    {256: ['ps3 sg', '@ADVL', 'Z Fst']},
    {257: ['ps3 sg', '@IMV', 'Z Fst']},
    {258: ['ps3 sg', '@PRD', 'Z Fst']},
    {259: ['@SUBJ', '@FMV', '@IMV']},
    {260: ['@FMV', '@SUBJ', 'Z Fst']},
    {261: ['@ADVL', '@FMV', '@ADVL']},
    {262: ['imper', ' S ', '@OBJ']},
    {263: ['imper', ' K ', '@OBJ']},
    {264: ['imper', ' P ', '@OBJ']},
    {265: ['ps1', ' S ', '@OBJ']},
    {266: ['ps1', ' K ', '@OBJ']},
    {267: ['ps1', ' P ', '@OBJ']},
    {268: ['ps3 sg', ' S ', '@OBJ']},
    {269: ['ps3 sg', ' K ', '@OBJ']},
    {270: ['ps3 sg', ' P ', '@OBJ']},
    {271: ['@FMV', ' S ', '@OBJ']},
    {272: ['@FMV', ' K ', '@OBJ']},
    {273: ['@FMV', ' P ', '@OBJ']},
    {274: ['imper', '@OBJ', 'Z Fst']},
    {275: ['@SUBJ', '@FCV', ' S ']},
    {276: ['@SUBJ', '@FCV', ' K ']},
    {277: ['imper', ' S ', 'Z Fst']},
    {278: ['imper', ' K ', 'Z Fst']},
    {279: ['imper', ' P ', 'Z Fst']},
    {280: ['imper', ' S ', 'D cap @ADVL']},
    {281: ['imper', ' K ', 'D cap @ADVL']},
    {282: ['imper', ' P ', 'D cap @ADVL']},
    {283: ['imper', '@OBJ', 'D cap @ADVL']},
    {284: ['pres ps1', ' S ', 'D cap @ADVL']},
    {285: ['pres ps1', ' K ', 'D cap @ADVL']},
    {286: ['pres ps1', ' P ', 'D cap @ADVL']},
    {287: ['pres ps1', '@OBJ', 'D cap @ADVL']},
    {288: ['pres ps3 sg', ' S ', 'D cap @ADVL']},
    {289: ['pres ps3 sg', ' K ', 'D cap @ADVL']},
    {290: ['pres ps3 sg', ' P ', 'D cap @ADVL']},
    {291: ['pres ps3 sg', '@OBJ', 'D cap @ADVL']},
    {292: ['impf ps1', ' S ', 'D cap @ADVL']},
    {293: ['impf ps1', ' K ', 'D cap @ADVL']},
    {294: ['impf ps1', ' P ', 'D cap @ADVL']},
    {295: ['impf ps1', '@OBJ', 'D cap @ADVL']},
    {296: ['impf ps3 sg', ' S ', 'D cap @ADVL']},
    {297: ['impf ps3 sg', ' K ', 'D cap @ADVL']},
    {298: ['impf ps3 sg', ' P ', 'D cap @ADVL']},
    {299: ['impf ps3 sg', '@OBJ', 'D cap @ADVL']},
    {300: ['@SUBJ', '@FMV', ' X ']},
    {301: ['@SUBJ', '@FCV', ' X ']},
    {302: ['@FCV', ' X ', '@IMV']},
    {303: ['@FMV', ' X ', '@OBJ']},
    {304: ['D cap @ADVL', '@FMV', '@SUBJ']},
    {305: ['impf ps3 sg', ' P ', 'D cap @ADVL']},
    {306: ['@FMV', 'Z Fst']},
    {307: ['imper', ' X ']}
])

